#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <vector>
#include <string>
#include <ctime>
#include <queue>
#include <map>
#include <set>

#ifdef WIN32
    #define I64 "%I64d"
#else
    #define I64 "%lld"
#endif // WIN32

#define next(x) (x + ((x) & (-x)))
#define prev(x) (x - ((x) & (-x)))
#define N 2002
#define md 1000000007
#define sqr(x) ((x) * (x))
#define INF (1 << 30)
#define EPS 0.00000001

using namespace std;
int n;
class T {
    public:
        vector<int> a;
        T(int n) {
            a = vector<int> (n + 1, 0);
        }

        void add(int pos) {
            for (int i = pos; i <= n; i = next(i)) {
                a[i]++;
            }
        }

        long long getsum(int l, int r) {
            if (l != 0) {
                return getsum(0, r) - getsum(0, l - 1);
            }
            long long result = 0;
            for (int i = r; i > 0; i = prev(i)) {
                result += a[i];
            }
            result += a[0];
            return result;
        }
};

int main() {
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // DEBUG

    srand(time(NULL));
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        vector<int> b;
        cin >> n;
        T tree(n);
        for (int j = 0; j < n; j++) {
            int x;
            cin >> x;
            b.push_back(x);
        }
        long long result = 0;
        for (int j = int(b.size()) - 1; j >= 0; j--) {
            result = tree.getsum(0, b[j] - 1);
            tree.add(b[j]);
            b[j] = result;
        }
        for (int j = 0; j < b.size(); j++) {
            cout << b[j] << " ";
        }
    }
    return 0;
}
