#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

void solve() {
	int n, m; scanf("%d%d", &n, &m);
	vector<vector<int> > a(n);
	vector<pii> edges;
	forn(i, m) {
		int fr, to; scanf("%d%d", &fr, &to); --fr, --to;
		edges.pb(mp(fr,to));
		a[fr].pb(to);
		a[to].pb(fr);
	}

	int ans = n+1;

	forn(ii, n) {
		vector<int> d(n, -1);
		vector<int> pred(n, -1);
		d[ii] = 0;
		queue<int> q;
		q.push(ii);
		while (!q.empty()) {
			int cur = q.front(); q.pop();
			forn(i, sz(a[cur])) {
				int to = a[cur][i];
				if (d[to] == -1) {
					pred[to] = cur;
					d[to] = d[cur]+1;
					q.push(to);
				}
			}
		}
		
		forn(ii, sz(edges)) {
			int fr = edges[ii].X;
			int to = edges[ii].Y;
			if (d[fr] != -1 && d[to] != -1 && pred[fr] != to && pred[to] != fr) ans = min(ans, d[fr]+d[to]+1);
		}
	}
	printf("%d\n", ans);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int T; scanf("%d", &T); while (T--) solve();
	return 0;
}
