#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>
#include <unordered_map>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;

void generateAll(ll i, ll n, set < ll > & was) {
	if(i >= n || was.count(i) > 0)
		return;
	was.insert(i);
	for(ll j = 2; j <= 9; j++)
		generateAll(i * j, n, was);
} 

bool rec(ll i, ll n, vector < bool > & used, vector < bool > & results, const vector < ll > & numbers) {
	if(i >= n)
		return false;
	int index = distance(numbers.begin(), lower_bound(numbers.begin(), numbers.end(), i));
	if(used[index]) return results[index];
	bool loseFound = false;
	for(ll j = 2; j <= 9; j++) {
		if(!rec(i * j, n, used, results, numbers)) {
			loseFound = true;
			break;
		}
	}
	used[index] = true;
	results[index] = loseFound;
	return loseFound;
}

int main() {
	ios_base::sync_with_stdio(false);
	int tests;
	cin >> tests;
	const ll maxValue = 1000000000;
	set < ll > was;
	generateAll(1, maxValue, was);
	vector < ll > allNumbers(was.begin(), was.end());
	int m = allNumbers.size();
	vector < bool > dWas(m, false);
	vector < bool > dResult(m, false);
	for(int test = 0; test < tests; test++) {
		ll n;
		cin >> n;
		//n = maxValue;
		fill(dWas.begin(), dWas.end(), false);
		bool result = rec(1, n, dWas, dResult, allNumbers);
		cout << (result ? 1 : 2) << "\n";
	}
	return 0;
}