#include <iostream>
#include <algorithm>
using namespace std;

const int modulo = 1e9;
const int max_k = 100;

const int max_n = 1e5;

int n, m;
int k, s;
int a[max_k];
int b[max_k];

int d[max_n + 1];

void ModuloInc(int& x, int y)
{
    x += y;
    if (x >= modulo) {
        x -= modulo;
    }
}

void Merge(int a[], int& n)
{
    if (n == 0) {
        return ;
    }

    int nn = 1;
    for (int i = 1; i < n; ++i) {
        if (a[i] != a[nn - 1]) {
            a[nn] = a[i];
            ++nn;
        }
    }

    n = nn;
}

int main()
{
    ios_base::sync_with_stdio(false);

    int tests;
    cin >> tests;
    for (int test = 0; test < tests; ++test) {
        cin >> n >> m;
        for (int i = n; i <= m; ++i) {
            d[i] = 0;
        }
        d[n] = 1;

        cin >> k;
        for (int i = 0; i < k; ++i) {
            cin >> a[i];
        }

        cin >> s;
        for (int i = 0; i < s; ++i) {
            cin >> b[i];
        }

        sort(a, a + k);
        sort(b, b + s);

        Merge(a, k);
        Merge(b, s);

        for (int i = n; i <= m; ++i) {
            for (int j = 0; j < k && i + a[j] <= m; ++j) {
                ModuloInc(d[i + a[j]], d[i]);
            }
            for (int j = 0; j < s && b[j] * i <= m; ++j) {
                ModuloInc(d[b[j] * i], d[i]);
            }
        }

        int answer = 0;

        for (int i = 0; i < s; ++i) {
            if (m % b[i] == 0) {
                int t = m / b[i];
                if (t >= n) {
                    ModuloInc(answer, d[t]);
                }
            }
        }

        cout << answer << endl;
    }

    return 0;
}
