#include <iostream>
#include <algorithm>

using namespace std;

long long INF = 1e16;

vector<pair<long long, long long>> fib;

long long gcd(long long a, long long b, long long &x, long long &y) {
    if (a == 0) {
        x = 0;
        y = 1;
        return b;
    } else {
        long long x1, y1, g = gcd(b % a, a, x1, y1);
        x = y1 - (b / a) * x1;
        y = x1;
        return g;
    }
}

bool try_solve(long long n, long long p, long long q, long long &a, long long &b) {
    if (n == p || n == q) {
        a = b = 1;
    return true;
    }
    long long x, y, g;
    g = gcd(p, q, x, y);
    x *= n / g;
    y *= n / g;

    //cout << p << " * " << x << " + " << q << " * " << y << " = " << n << endl;

    long long rm = 2e9 + 10;
    long long lm = -2e9 - 10;

    long long t = y / p;

    if (t * p >= y) {
        --t;
    }

    rm = min(rm, t);

    t = (y - x) / (p + q);

    if (t * (p + q) >= y - x) {
        --t;
    }

    rm = min(rm, t);

    t = -x / q;

    if (t * q <= -x) {
        ++t;
    }

    lm = max(lm, t);

    if (lm > rm) {
        return false;
    } else {
        b = y - p * rm;
        a = x + q * rm;
        return true;
    }
}

void solve(long long n, long long &a, long long &b) {
    a = 1;
    b = n - 1;
    for (int i = 0; i < (int) fib.size(); ++i) {
        long long a1, b1;
        if (try_solve(n, fib[i].second, fib[i].first, a1, b1)) {
            //cout << a1 << " " << b1 << endl;
            if (b1 < b || (b1 == b && a1 < a)) {
                a = a1;
                b = b1;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    fib.push_back(make_pair(1, 1));
    for (int i = 0; i < 55; ++i) {
        long long x = fib.back().first, y = fib.back().second;
        x = x + y;
        y = x - y;
        fib.push_back(make_pair(x, y));
    }
    int t;
    cin >> t;
    while (t--) {
        long long n, a, b;
        cin >> n;
        solve(n, a, b);
        cout << a << ' ' << b << endl;
    }
    return 0;
}
