#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>

using namespace std;

const int MOD = 2017;

int matrix[15][15], ans[15][15], t[15][15];

void multiply(int a[][15], int b[][15]) {
    for (int i = 0; i < 15; i++) {
        for (int j = 0; j < 15; j++) {
            t[i][j] = 0;
            for (int k = 0; k < 15; k++) {
                t[i][j] = (t[i][j] + a[i][k] * b[k][j]) % MOD;
            }
        }
    }
}

void square() {
    multiply(ans, ans);

    for (int i = 0; i < 15; i++) {
        for (int j = 0; j < 15; j++) {
            ans[i][j] = t[i][j];
        }
    }
}

void multiply() {
    multiply(ans, matrix);

    for (int i = 0; i < 15; i++) {
        for (int j = 0; j < 15; j++) {
            ans[i][j] = t[i][j];
        }
    }
}

void powMod(int n) {
    if (n == 0) {
        for (int i = 0; i < 15; i++) {
            for (int j = 0; j < 15; j++) {
                ans[i][j] = 0;
            }
        }

        for (int i = 0; i < 15; i++) {
            ans[i][i] = 1;
        }

        return;
    }

    powMod(n / 2);

    square();

    if (n & 1) {
        multiply();
    }
}

int main() {
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);

    /*
    freopen("task.in", "r", stdin);
    freopen("task.out", "w", stdout);
    */

    for (int i = 1; i < 15; i++) {
        matrix[i - 1][i] = 1;
        matrix[i][i] = i;
    }

    int tests;

    cin >> tests;

    for (int test = 0; test < tests; test++) {
        int n, k;

        cin >> n >> k;

        powMod(n);

        cout << ans[0][k] << endl;
    }

    return 0;
}
