#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>
#include <memory.h>
#include <unordered_map>

#define forn(i, n) for(int i = 0; i < (int)(n); ++i)
#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i) 
#define for1(i, n) for(int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;

const int mod = 2017;

int add(int x, int y) {
	if( (x += y) >= mod )
		x -= mod;
	return x;
}

int sub(int x, int y) {
	if( (x -= y) < 0 )
		x += mod;
	return x;
}

int mul(int x, int y) {
	return x * y % mod;
}

int power(int x, int n) {
	int r = 1;
	while( n ) {
		if( n & 1 ) r = mul(r, x);
		if( n /= 2 ) x = mul(x, x);
	} return r;
}

int inv[mod];

int mdiv(int x, int y) {
	assert( 0 < y && y < mod );
	return mul(x, inv[y]);
}

int cnk[20][20];

void solve() {
	int r = 0;
	int n, k;
	cin >> n >> k;
	fore(z, 1, k) {
		int f = power(z, n);
		f = mul(f, cnk[k][z]);
		if( (k - z) % 2 == 0 ) {
			r = add(r, f);
		} else {
			r = sub(r, f);
		}
	}
	int fact = 1;
	fore(i, 1, k) fact = mul(fact, i);
	cout << mdiv(r, fact) << '\n';
}

int main() {
	forn(i, 20) {
		cnk[i][0] = cnk[i][i] = 1;
		fore(j, 1, i - 1 )
			cnk[i][j] = add(cnk[i-1][j-1], cnk[i-1][j]);
	}
	forn(i, mod) if( i ) {
		forn(j, mod) if( mul(i, j) == 1 )
			inv[i] = j;
		assert( inv[i] );
	}
	cin.sync_with_stdio();
	cin.tie(0);
	cout.precision(12);
	cout << fixed;
	cerr.precision(12);
	cerr << fixed;
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int T;
	cin >> T;
	forn(t, T) {
		solve();
	}
	return 0;
}
