#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MAXN = 100500;
const int MOD = 1000000000;

int cntA[MAXN], cntM[MAXN];
int n, m;
int a[111], b[111];

ll
gcd(ll a, ll b, ll &x, ll &y)
{
	if (b == 0) {
		x = 1, y = 0;
		return a;
	}
	ll mod = a % b;
	ll div = a / b;
	ll nx, ny;
	ll res = gcd(b, mod, ny, nx);
	x = nx;
	y = ny - div * x;
	return res;
}

void
solve(ll n, ll a, ll b, ll &ansx, ll &ansy)
{
	ll x, y;
	ll curG = gcd(a, b, x, y);
	ll x0 = x * n, y0 = y * n;
	if (x < 0ll) {
		ll k = (y0 - x0) / (b + a);
		ll nx = x0 + b * k, ny = y0 - a * k;
		if (nx > 0 && ny > 0 && nx <= ny) {
			ansx = nx;
			ansy = ny;
		}
	} else {
		ll k = (x0 - y0 + a + b - 1) / (a + b);
		ll nx = x0 - b * k, ny = y0 + a * k;
		if (nx > 0 && ny > 0 && nx <= ny) {
			ansx = nx;
			ansy = ny;
		}
	}
}

void
process()
{
	ll n;
	scanf("%lld", &n);
	pair< ll, ll > res = mp((n + 1) / 2, n / 2);
	{
		ll cy = (n + 2) / 3;
		ll cx = n - 2 * cy;
		if (cx > 0 && cy > 0 && cx <= cy) {
			res = min(res, mp(cy, cx));
		}
	}
	ll ca = 2, cb = 3;
	while (ca + cb <= n) {
		ll tmpx = -1ll, tmpy = -1ll, tmp = -1ll;
		solve(n, ca, cb, tmpx, tmpy);
		if (tmpx != -1ll) {
			res = min(res, mp(tmpy, tmpx));
		}
		tmp = ca + cb;
		ca = cb;
		cb = tmp;
	}
	printf("%lld %lld\n", res.second, res.first);
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		process();
	}
	return 0;
}