#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

const int kN = 100 * 1000;

struct FT {
  vector<int> data;

  FT(int n) {
    data.resize(n);
  }

  int Sum(int r) {
    int res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1) {
      res += data[r];
    }
    return res;
  }

  int Sum(int l, int r) {
    return Sum(r) - Sum(l - 1);
  }

  void Update(int pos, int x) {
    for (; pos < data.size(); pos = pos | (pos + 1)) {
      data[pos] += x;
    }
  }
};

int main() {
  std::ios_base::sync_with_stdio(false);
  int t;
  cin >> t;
  for (int t_ = 0; t_ < t; ++t_) {
    int n;
    cin >> n;
    FT tree(n + 2);
    vector<int> arr(n + 2);
    for (int i = 0; i < n; ++i) {
      cin >> arr[i];
    }
    vector<int> res(n);
    for (int i = n - 1; i >= 0; --i) {
      res[i] = tree.Sum(0, arr[i] - 1);    
      tree.Update(arr[i], 1);
    }
    for (int i = 0; i < n; ++i) {
      cout << res[i] << ' ';
    }
    cout << '\n';
  } 
  return 0;
}
