#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

string mul(string a, string b) {
    ll x = 0,
       y = 0;
    for (int i = 0; i < size(a); i++) {
        x = x * 2 + a[i] - '0';
    }
    for (int i = 0; i < size(b); i++) {
        y = y * 2 + b[i] - '0';
    }

    ll res = x * y;
    if (res == 0) return "0";
    stringstream outp;

    while (res) {
        outp << static_cast<char>((res % 2) + '0');
        res /= 2;
    }

    string s = outp.str();
    reverse(s.begin(), s.end());
    return s;
}

string pad(string s, int l, int r) {
    stringstream outp;
    for (int i = 0; i < l; i++)
        outp << " ";
    outp << s;
    for (int i = 0; i < r; i++)
        //outp << " ";
        outp << " ";
    return outp.str();
}

string line(int a, int b, int c) {
    stringstream ss;
    for (int i=  0  ; i < a; i++) ss <<" ";
    for (int i=  0  ; i < b; i++) ss <<"-";
    for (int i=  0  ; i < c; i++) ss <<" ";
    return ss.str();
}

int main() {

    int ts;
    scanf("%d\n", &ts);

    for (int t = 0; t < ts; t++) {
        if (t != 0) cout << endl;

        cout << "Test " << (t+1) << endl;

        string a, b;
        cin >> a >> b;

        string res = mul(a, b);
        int len = max(size(res), max(size(a), size(b)));

        cout << pad(a, len - size(a), 0) << endl;
        cout << pad(b, len - size(b), 0) << endl;
        cout << line(len - max(size(a), size(b)), max(size(a), size(b)), 0) << endl;

        int width = size(a) + size(b) - 1;

        for (int i = size(b) - 1; i >= 0; i--) {
            string cur = "";
            if (b[i] == '0') {
                for (int j = 0; j < size(a); j++) {
                    cur += "0";
                }
            } else {
                cur = a;
            }

            int curlen = i + max(0, len - width) + size(a);
            cout << pad(cur, i + max(0, len - width), max(width, len) - curlen) << endl;
        }

        cout << line(0, max(width, len), 0) << endl;

        cout << pad(res, max(width, len) - size(res), 0) << endl;
    }

    return 0;
}
