#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

int main() {
    long long mod = 1000000000;

    int ts;
    scanf("%d\n", &ts);


    for (int t = 0; t <ts; t++) {
        int n, m;
        scanf("%d %d\n", &n, &m);

        int k;
        scanf("%d\n", &k);
        vi add;
        set<int> adds;
        for (int i = 0; i < k; i++) {
            int cur;
            scanf("%d", &cur);
            if (adds.find(cur) == adds.end()) {
                add.push_back(cur);
                adds.insert(cur);
            }
        }

        sort(add.begin(), add.end());

        int s;
        scanf("%d\n", &s);
        vi mul;
        set<int> muls;
        for (int i = 0; i < s; i++) {
            int cur;
            scanf("%d", &cur);
            if (muls.find(cur) == muls.end()){ 
                muls.insert(cur);
                mul.push_back(cur);
            }
        }

        sort(mul.begin(), mul.end());

        int *dp = new int[m + 1];
        memset(dp, 0, (m + 1) << 2);
        dp[n] = 1;
        for (int i = n; i < m; i++){ 
            //cout << i << " " << dp[i] << endl;
            for (int j = 0; j < size(add) && i + add[j] < m; j++) {
                dp[i + add[j]] += dp[i];
                dp[i + add[j]] %= mod;
            }
            for (int j=  0; j < size(mul) && (ll)i * mul[j]  <= m; j++) {
                dp[i * mul[j]] += dp[i];
                dp[i * mul[j]] %= mod;
            }
        }

        cout << dp[m] << endl;
    }


    return 0;
}
