#define _USE_MATH_DEFINES

#include <iostream>
#include <cstdio>
#include <cstring>
#include <string>
#include <iomanip>
#include <vector>
#include <cassert>
#include <set>
#include <queue>
#include <algorithm>
#include <bitset>
#include <map>
#include <stack>
#include <ctime>
#include <cmath>

using namespace std;

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define all(a) a.begin(),a.end()
#define pb push_back
#define mp make_pair
#define sz(a) (int)(a.size())

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

int n;

int gcd(int a, int b, li& x, li& y) {
    if (b == 0) {
        x = 1;
        y = 0;
        return a;
    }

    li cx, cy;
    int g = gcd(b, a % b, cx, cy);

    x = cy;
    y = cx - cy * (a / b);

    return g;
}

bool read() {
    if (!(cin >> n))
        return false;
    return true;
}

pair<li,li> try_solve(int a, int b) {
    li x, y;
    int g = gcd(a, b, x, y);

    assert(x * a + y * b == g);

    if (n % g != 0)
        return mp(INF64, INF64);

    x *= n / g;
    y *= n / g;

    li dx = b / g;
    li dy = a / g;

    li my = (y % dy + dy) % dy;
    li k = (y - my) / dy;

    x += k * dx;
    y -= k * dy;

    li l = 0, r = 1e9;
    while (r - l > 1) {
        int m = (l + r) >> 1;
        if (y + m * dy >= x - m * dx)
            r = m;
        else
            l = m;
    }

    y += l * dy;
    x -= l * dx;

    int cnt = 0;
    while (y < x) {
        y += dy, x -= dx;
        assert(cnt < 10);
    }

    if (x <= 0)
        return mp(INF64, INF64);

    return mp(y, x);
}

void solve() {
    li f1 = 1;
    li f2 = 1;

    try_solve(34, 55);

    pair<li,li> res = mp(INF64, INF64);

    while (f2 <= n) {
        res = min(res, try_solve(f1, f2));
        f1 += f2;
        swap(f1, f2);
    }

    printf("%I64d %I64d\n", res.sc, res.ft);
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif

    int t;
    scanf("%d", &t);

    while (read())
        solve();

    return 0;
}