#include <iostream>
#include <cstdio>
#include <climits>
#include <queue>

using namespace std;


int main() {
	cin.sync_with_stdio(false);
	
	int T;
	cin >> T;
		
	while(T--) {
		int n, m;
		cin >> n >> m;
		
		vector<vector<int>> G(n);	
		for(int i = 0; i < m; ++i) {
			int a, b;
			cin >> a >> b;
			--a;
			--b;
			G[a].push_back(b);
			G[b].push_back(a);
		}
		
		int ret = INT_MAX;
		for(int i = 0; i < n; ++i) {
			vector<int> dist(n, -1);
			dist[i] = 0;
			queue<int> Q;
			Q.push(i);
			
			while(!Q.empty()) {
				int v = Q.front();
				Q.pop();
				for(int x : G[v]) {
					if(dist[x] != -1) {
						ret = min(ret, dist[v] + dist[x] + 1);
						continue;
					}
					dist[x] = dist[v] + 1;
					Q.push(x);
				}
			}
		}
		cout << ret << "\n";
	}
	
	return 0;
}
